#ifndef HtmlHighlighter_h
#define HtmlHighlighter_h

/******************************************************************************
*
* Copyright (C) 2002 Hugo PEREIRA <mailto: hugo.pereira@free.fr>
*
* This is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
*
* This software is distributed in the hope that it will be useful, but WITHOUT
* Any WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along with
* this program.  If not, see <http://www.gnu.org/licenses/>.
*
*******************************************************************************/

#include "Counter.h"

#include <QObject>
#include <QRegExp>
#include <QTextCursor>

class HtmlHighlighter: public QObject, public Counter
{

    Q_OBJECT

    public:

    //* constructor
    HtmlHighlighter( QObject* );

    //* destructor
    virtual ~HtmlHighlighter( void ) = default;

    //* enable
    bool setEnabled( bool value )
    {
        if( enabled_ == value ) return false;
        enabled_ = value;
        return true;
    }

    //* replace html links in text from cursor
    void process( QTextCursor );

    private:

    //* enabled
    bool enabled_ = true;

    //* html regexp, needed to detect links
    QRegExp regexp_;

};


#endif
