#ifndef MessageEditorWidget_h
#define MessageEditorWidget_h

/******************************************************************************
*
* Copyright (C) 2002 Hugo PEREIRA <mailto: hugo.pereira@free.fr>
*
* This is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
*
* This software is distributed in the hope that it will be useful, but WITHOUT
* Any WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along with
* this program.  If not, see <http://www.gnu.org/licenses/>.
*
*******************************************************************************/

#include "LineEditor.h"

class MessageEditorWidget: public LineEditor
{

    Q_OBJECT

    public:

    //* constructor
    MessageEditorWidget( QWidget* = nullptr );


    //*@name modifiers
    //@{

    //* install actions in context menu
    virtual void installContextMenuActions( BaseContextMenu* );

    //@}

    //*@name actions
    //@{

    //* remove message action
    QAction& removeMessageAction( void ) const
    { return *removeMessageAction_; }

    //* cancel message edition
    QAction& cancelMessageEditionAction( void ) const
    { return *cancelMessageEditionAction_; }

    //@}

    private:

    //* install actions
    void _installActions( void );

    //*@name actions
    //@{

    //* remove message action
    QAction* removeMessageAction_ = nullptr;

    //* edit message action
    QAction* cancelMessageEditionAction_ = nullptr;

    //@}
};

#endif
